<template>
  <div class="w-full">
    <h2 class="mb-4">Recovery Prognosis</h2>

    <div :class="confidenceClass">
      <svg class="w-24 h-24">
        <svg viewBox="0 0 100 100" class="stroke-current">
          <path
            :d="describeArc(50, 50, 42, 0, (confidence * 360) / 100)"
            stroke-width="5"
            fill="none"
          />
        </svg>
        <text
          id="confidence"
          class="text-4xl"
          x="50%"
          y="50%"
          text-anchor="middle"
          dominant-baseline="central"
        >
          {{ confidence }}%
        </text>
      </svg>

      <div :class="preditionClass">
        {{ prediction }}
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";

function polarToCartesian(centerX, centerY, radius, angleInDegrees) {
  const angleInRadians = ((angleInDegrees - 90) * Math.PI) / 180.0;

  return {
    x: centerX + radius * Math.cos(angleInRadians),
    y: centerY + radius * Math.sin(angleInRadians)
  };
}

function status(result) {
  let suc = result.classification.SUCCESS;
  let ins = result.classification.UNSATISFACTORY;

  if (suc > ins) {
    return {
      prediction: "SATISFACTORY",
      confidence: 100 * (suc / (suc + ins))
    };
  } else {
    return {
      prediction: "UNSATISFACTORY",
      confidence: 100 * (ins / (suc + ins))
    };
  }
}

export default {
  computed: {
    ...mapState(["classifications", "selectedClassification"]),

    classification() {
      return this.classifications[this.selectedClassification];
    },
    confidence() {
      return Math.round(status(this.classification).confidence);
    },
    prediction() {
      return status(this.classification).prediction;
    },
    confidenceClass() {
      if (status(this.classification).prediction == "SATISFACTORY")
        return "text-teal flex flex-row items-center" ;

      return "text-orange flex flex-row items-center" ;
    },
    preditionClass() {
      if (status(this.classification).prediction == "SATISFACTORY")
        return "mx-2 p-8 flex-grow text-lg text-white bg-teal-dark flex flex-row justify-center items-center" ;

      return "mx-2 p-8 flex-grow text-lg text-white bg-orange-dark flex flex-row justify-center items-center" ;
    }
  },
  methods: {
    describeArc(centerX, centerY, radius, startAngle, endAngle) {
      const start = polarToCartesian(centerX, centerY, radius, endAngle);
      const end = polarToCartesian(centerX, centerY, radius, startAngle);

      const diff = endAngle - startAngle;
      const largeArcFlag = diff === 0 || diff > 180 ? "1" : "0";

      return `M ${start.x} ${start.y} A ${radius} ${radius}
          0 ${largeArcFlag} 0 ${end.x} ${end.y}`;
    }
  }
};
</script>
